package com.jasamedika.medifirst2000.controller;

import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.dao.LoginUserDao;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.security.model.UserAuthentication;
import com.jasamedika.medifirst2000.service.ActivityPegawaiService;
import com.jasamedika.medifirst2000.service.DiagnosaTindakanPasienService;
import com.jasamedika.medifirst2000.vo.DiagnosaTindakanPasienVO;
import com.jasamedika.medifirst2000.vo.PegawaiVO;
import org.slf4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.security.core.userdetails.User;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import java.util.Date;
import java.util.Map;

import static com.jasamedika.medifirst2000.constants.Constants.MessageInfo.ERROR_MESSAGE;
import static com.jasamedika.medifirst2000.core.web.WebConstants.AUTH_HEADER_NAME;
import static com.jasamedika.medifirst2000.core.web.WebConstants.HttpHeaderInfo.LABEL_ERROR;
import static com.jasamedika.medifirst2000.core.web.WebConstants.HttpHeaderInfo.LABEL_SUCCESS;
import static com.jasamedika.medifirst2000.security.service.TokenAuthenticationService.tokenHandler;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonHttpStatus;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonResponse;
import static org.slf4j.LoggerFactory.getLogger;
import static org.springframework.http.HttpStatus.*;
import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
import static org.springframework.web.bind.annotation.RequestMethod.GET;
import static org.springframework.web.bind.annotation.RequestMethod.POST;

/**
 * Controller class for Registrasi Pasien Business
 * 
 * @author Adik
 */
@RestController
@RequestMapping("/diagnosa-tindakan-pasien")
public class DiagnosaTindakanPasienController extends LocaleController<DiagnosaTindakanPasienVO> {

	private static final Logger LOGGER = getLogger(DiagnosaTindakanPasienController.class);

	@Autowired
	private LoginUserDao loginUserDao;

	@Autowired
	private ActivityPegawaiService activityPegawaiServiceImpl;

	@Autowired
	private DiagnosaTindakanPasienService diagnosaTindakanPasienService;

	@RequestMapping(value = "/save-diagnosa-tindakan-pasien", method = POST, produces = APPLICATION_JSON_VALUE, consumes = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> saveDiagnosaTindakanPasien(
			@Valid @RequestBody DiagnosaTindakanPasienVO vo, HttpServletRequest request) {
		try {
			Map<String, Object> result = diagnosaTindakanPasienService.saveDiagnosaTindakanPasien(vo);
			if (null != result)
				mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			String token = request.getHeader(AUTH_HEADER_NAME);
			final User user = tokenHandler.parseUserFromToken(token);
			if (user != null) {
				UserAuthentication data = new UserAuthentication(user);
				PegawaiVO pegawai = new PegawaiVO();
				pegawai.setId(loginUserDao.findByNamaUser(data.getName()).get(0).getPegawai().getId());
				activityPegawaiServiceImpl.record(pegawai, new Date(), "Memasukan Diagnosis");
				BroadcastMessage("IKI", "");
			}
			return getJsonResponse(result, CREATED, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when saveDiagnosaTindakanPasien", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when saveDiagnosaTindakanPasien", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

	@RequestMapping(value = "/get-diagnosa-tindakan-by-antrian", method = GET)
	public ResponseEntity<Map<String, Object>> getDiagnosaByAntrian(@RequestParam(value = "noRec") String noRec,
			HttpServletRequest request) {
		try {
			Map<String, Object> result = diagnosaTindakanPasienService.findDiagnosaTindakanPasienByAntrian(noRec);
			boolean dataFound = (boolean) result.get("dataFound");
			mapHeaderMessage.clear();
			if (dataFound) {
				mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			} else {
				mapHeaderMessage.put(LABEL_ERROR, getMessage(MessageResource.LABEL_ERROR, request));
			}
			return getJsonResponse(result, OK, mapHeaderMessage);
		} catch (ServiceVOException e) {
			LOGGER.error("Got ServiceVOException {} when findDiagnosaTindakanPasienByAntrian", e.getMessage());
			addHeaderMessage(ERROR_MESSAGE, e.getMessage());
			return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got JpaSystemException {} when findDiagnosaTindakanPasienByAntrian", jse.getMessage());
			addHeaderMessage(ERROR_MESSAGE, jse.getMessage());
			return getJsonHttpStatus(CONFLICT, mapHeaderMessage);
		}
	}

}
